#ifndef _zsdl_h_
#define _zsdl_h_

#include <SDL.h>

inline int convert_point(int val) {
  return (val * 7) >> 4;
}

inline void convert_rect(SDL_Rect* s, SDL_Rect* d) {
  d->x = convert_point(s->x);
  d->y = convert_point(s->y);
  d->w = convert_point(s->w);
  d->h = convert_point(s->h);
}

inline int unconvert_point(int val) {
  return val * 16 / 7;
}

inline int ZSDL_BlitSurface(SDL_Surface* s, SDL_Rect* sr,
							SDL_Surface* d, SDL_Rect* dr)
{
  if (sr == 0) {
	if (dr == 0) {
	  return SDL_BlitSurface(s, 0, d, 0);
	}
	SDL_Rect ndr;
	convert_rect(dr, &ndr);
	return SDL_BlitSurface(s, 0, d, &ndr);
  }
  SDL_Rect nsr, ndr;
  convert_rect(sr, &nsr);
  convert_rect(dr, &ndr);
  return SDL_BlitSurface(s, &nsr, d, &ndr);
}

inline void ZSDL_FillRect(SDL_Surface* s, SDL_Rect* r, Uint32 c) {
  if (r) {
	SDL_Rect nr;
	convert_rect(r, &nr);
	SDL_FillRect(s, &nr, c);
  }
  else {
	SDL_FillRect(s, 0, c);
  }
}

inline int NSDL_BlitSurface(SDL_Surface* s, SDL_Rect* sr,
							SDL_Surface* d, SDL_Rect* dr)
{
  SDL_BlitSurface(s, sr, d, dr);
}

inline void NSDL_FillRect(SDL_Surface* s, SDL_Rect* r, Uint32 c) {
  SDL_FillRect(s, r, c);
}

/*
SDL_Surface* ZSDL_CreateRGBSurface(Uint32 flags, int width, int height,
								  int depth, Uint32 Rmask, Uint32 Gmask,
								  Uint32 Bmask, Uint32 Amask)
{
  width = convert_point(width);
  height = convert_point(height);
  return SDL_CreateRGBSurface(flags, width, height, depth,
							  Rmask, Gmask, Bmask, Amask);
}
*/

#define SDL_BlitSurface(a1, a2, a3, a4) ZSDL_BlitSurface(a1, a2, a3, a4)
#define SDL_FillRect(a1, a2, a3) ZSDL_FillRect(a1, a2, a3)
/*
#define SDL_CreateRGBSurface(a1,a2,a3,a4,a5,a6,a7,a8) \
        ZSDL_CreateRGBSurface(a1,a2,a3,a4,a5,a6,a7,a8)
*/
#endif
